// I is a straight extension of an edge
// Xij means a crossing with i edges above, and the jth edge goes over
// X2iVj means a crossing with 2 opposite edges above, with i corresponding
//     to the strand attached above (over/under) and a virtual crossing in
//     the jth position below (j is arbitrary, if based only on this crossing)
//  example: X2OV1:
// |     |
// \ /-\ /
//  X   /   <-- X is a virtual crossing
// / \-/ \
// |     |
// V is a virtual crossing
// WL is a left side wrap-around
// WR is a right side wrap-around
// C is a circle (for drawing the unknot)
// END is the end of a row (or by itself, the end of the drawing
typedef enum move
  {X01, X02, X11, X12, X21, X22, X31, X32, X41, X42,
   X2OV1, X2OV2, X2UV1, X2UV2, V, I, WL, WR, C, END} move;

move **layout(PD);
int abovemovesize(move);
int belowmovesize(move);
void freemoves(move **);
void printmoves(move **);

void drawPS(FILE *, code, int, int);
void ldrawPS(FILE *, code, int, int, int);
void drawPNG(char *, code, int, int);
