#include <stdlib.h>
#include <stdio.h>
#include "gauss.h"
#include "moves.h"
#include "pd.h"
#include "draw.h"

int main(int argc, char *argv[]) {
  if (argc < 3) {
    printf("Usage: genlowest <max crossings> <number of crossings for output> [0 for non-cyclic] [1 for reversible]\n");
    return 0;
  }
  int sz = atoi(argv[1]);
  int maxp = atoi(argv[2]);
  cyclic = (argc >= 4 ? atoi(argv[3]) : 1);
  reversible = (argc == 5 ? atoi(argv[4]) : 0);
  initcrossings(sz);
  int n;
  code *codes = genallcodes(maxp, &n);
  //int *lowest = findlowest(codes, n, sz);
  //initlowest(FILENAME, 0);
  initlowest(sz);
  n <<= sz - maxp;

  int i, m = 0, j = 0;
  FILE *f = fopen("out.ps", "w");
  fprintf(f, "%%!PS-Adobe-3.0\n%%%%Pages: (atend)\n%%%%EndComments\n\n");
  for (i = 0; i < n; i++) {
    if (getlowest(i) == -1) {
      code c = getcode(codes, sz, i);
      if (c.n != -1) {
	if (c.n <= maxp) {
	  if (j % 80 == 0)
	    fprintf(f, "%%%%Page: %d %d\n",(j + 1) / 80 + 1, (j + 1) / 80 + 1);
	  //PD p = code2PD(c);
	  //move **mov = layout(p);
	  fprintf(f, "gsave\n");
	  fprintf(f, "%d %d translate\n", (j % 8) * 72 + 18,
		  666 - ((j / 8) % 10) * 72);
	  fprintf(f, "%f %f scale\n", 72.0 / 500, 72.0 / 500);
	  fprintf(f, "%%%%BeginDocument\n");
	  drawPS(f, c, 1, 0);
	  fprintf(f, "%%%%EndDocument\n");
	  fprintf(f, "grestore\n");
	  //freePD(p);
	  //freemoves(mov);
	  if (j % 80 == 79)
	    fprintf(f, "showpage\n");
	  j++;
	}
	free(c.code);
      }
    }
  }
  if (j % 80 != 0)
    fprintf(f, "showpage\n");
  fprintf(f, "%%%%Trailer\n%%%%Pages: %d\n%%%%EOF\n", (j - 1) / 80 + 1);
  fclose(f);
  printf("Number of unique codes: %d\n", j);
  return 0;
}
