#include <stdlib.h>
#include <stdio.h>
#include "gauss.h"

int main(int argc, char *argv[]) {
  if (argc < 2) {
    printf("Usage: genallgauss <number of crossings> [0 for non-cyclic] [1 for reversible]\n");
    return 0;
  }
  int sz = atoi(argv[1]);
  cyclic = (argc >= 3 ? atoi(argv[2]) : 1);
  reversible = (argc == 4 ? atoi(argv[3]) : 0);
  int n, m = 0;
  code *codes = genallcodes(sz, &n);

  int i;
  for (i = 0; i < n; i++) {
    code c = getcode(codes, sz, i);
    if (c.n != -1) {
      m++;
      printcode(c);
      free(c.code);
    }
  }
  printf("Number of codes: %d; space used: %d\n", m, n);

  return 0;
}
