#include <stdlib.h>
#include <stdio.h>
#include "gauss.h"
#include "moves.h"
#include "poly.h"

int main(int argc, char *argv[]) {
  if (argc < 3) {
    printf("Usage: getknots <max crossings> <number of crossings for output> [0 for non-cyclic] [1 for reversible]\n");
    return 0;
  }
  int sz = atoi(argv[1]);
  int maxp = atoi(argv[2]);
  cyclic = (argc >= 4 ? atoi(argv[3]) : 1);
  reversible = (argc == 5 ? atoi(argv[4]) : 0);
  initcrossings(15 * sz);
  //initpascal(17 * sz);
  knot n;
  code *codes = genallcodes(maxp, &n);
  //int *lowest = findlowest(codes, n, sz);
  //findlowest(codes, n, sz);
  //initlowest(FILENAME, 0);
  initlowest(sz);
  n <<= sz - maxp;

  knot i, m = 0, j = 0;
  for (i = 0; i < n; i++) {
    code c = getcode(codes, sz, i);
    if (c.n != -1) {
      if (c.n <= maxp) {
	//j++;
	knot l = getlowest(i);
	if (l == -1) { //lowest[i] == -1) {
	  //printf("*%d*\t", i);
	  m++;
	  //} else
	  //printf("%d\t", l); //lowest[i]);
	/*poly p = multijonespoly(c, 3);
	  printpoly(p);
	  printf(" \t");
	  free(p.coeffs);*/
	/*twopoly tp = genalexander(c);
	printtwopoly(tp);
	printf(" \t");
	freetwopoly(tp);*/
	//printf("%d ", Jinvar(c));

	  int f = isfirst(i, codes, n, sz);
	  if (f == -1) {
	    free(c.code);
	    continue;
	  }

	  if (!reversible)
	    printf("%c", f & 8 ? 'i' : '-');
	  printf("%c%c%c ", f & 4 ? 'd' : '-', f & 2 ? 'h' : '-',
		 f & 1 ? 'v' : '-');
	  //printf("%d ", f & 3);
	  printcode(c);
	  j++;
	}
      }
      free(c.code);
    }
  }
  printf("Number of knots: " KNOT_PRINTF "; output: " KNOT_PRINTF "\n", m, j);

  return 0;
}
